"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomOptions = exports.EditorReference = exports.Toolbar = exports.Validation = exports.Sx = exports.NotFullWidth = exports.Large = exports.Medium = exports.Small = exports.ReadOnly = exports.Disabled = exports.Basic = void 0;
var React = __importStar(require("react"));
var ra_core_1 = require("ra-core");
var ra_ui_materialui_1 = require("ra-ui-materialui");
var react_hook_form_1 = require("react-hook-form");
var ra_data_fakerest_1 = __importDefault(require("ra-data-fakerest"));
var react_router_dom_1 = require("react-router-dom");
var extension_mention_1 = __importDefault(require("@tiptap/extension-mention"));
var react_1 = require("@tiptap/react");
var tippy_js_1 = __importDefault(require("tippy.js"));
var RichTextInput_1 = require("./RichTextInput");
var RichTextInputToolbar_1 = require("./RichTextInputToolbar");
var material_1 = require("@mui/material");
var buttons_1 = require("./buttons");
exports.default = { title: 'ra-input-rich-text/RichTextInput' };
var FormInspector = function (_a) {
    var _b = _a.name, name = _b === void 0 ? 'body' : _b;
    var value = (0, react_hook_form_1.useWatch)({ name: name });
    return (React.createElement(material_1.Box, { sx: function (theme) { return ({ backgroundColor: theme.palette.divider }); } },
        name,
        " value in form:\u00A0",
        React.createElement("code", null,
            JSON.stringify(value),
            " (",
            typeof value,
            ")")));
};
var i18nProvider = {
    translate: function (key, options) { var _a; return (_a = options === null || options === void 0 ? void 0 : options._) !== null && _a !== void 0 ? _a : key; },
    changeLocale: function () { return Promise.resolve(); },
    getLocale: function () { return 'en'; },
};
var Basic = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { source: "body" }),
                React.createElement(FormInspector, null)))))); };
exports.Basic = Basic;
var Disabled = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { source: "body", disabled: true }),
                React.createElement(FormInspector, null)))))); };
exports.Disabled = Disabled;
var ReadOnly = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { source: "body", readOnly: true }),
                React.createElement(FormInspector, null)))))); };
exports.ReadOnly = ReadOnly;
var Small = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { toolbar: React.createElement(RichTextInputToolbar_1.RichTextInputToolbar, { size: "small" }), label: "Body", source: "body" }),
                React.createElement(FormInspector, null)))))); };
exports.Small = Small;
var Medium = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { toolbar: React.createElement(RichTextInputToolbar_1.RichTextInputToolbar, { size: "medium" }), label: "Body", source: "body" }),
                React.createElement(FormInspector, null)))))); };
exports.Medium = Medium;
var Large = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { toolbar: React.createElement(RichTextInputToolbar_1.RichTextInputToolbar, { size: "large" }), label: "Body", source: "body" }),
                React.createElement(FormInspector, null)))))); };
exports.Large = Large;
var NotFullWidth = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { toolbar: React.createElement(RichTextInputToolbar_1.RichTextInputToolbar, null), label: "Body", source: "body", fullWidth: false }),
                React.createElement(FormInspector, null)))))); };
exports.NotFullWidth = NotFullWidth;
var Sx = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { label: "Body", source: "body", sx: { border: '1px solid red' } }),
                React.createElement(FormInspector, null)))))); };
exports.Sx = Sx;
var Validation = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { label: "Body", source: "body", validate: (0, ra_core_1.required)() }),
                React.createElement(FormInspector, null)))))); };
exports.Validation = Validation;
var MyRichTextInputToolbar = function (_a) {
    var props = __rest(_a, []);
    return (React.createElement(RichTextInputToolbar_1.RichTextInputToolbar, __assign({}, props),
        React.createElement(buttons_1.FormatButtons, null)));
};
var Toolbar = function (props) { return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
    React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
        React.createElement(material_1.Card, null,
            React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, onSubmit: function () { } }, props),
                React.createElement(RichTextInput_1.RichTextInput, { source: "body", toolbar: React.createElement(MyRichTextInputToolbar, null) }),
                React.createElement(FormInspector, null)))))); };
exports.Toolbar = Toolbar;
var EditorReference = function (props) {
    var editorRef = React.useRef(null);
    var EditorToolbar = function () { return (React.createElement(ra_ui_materialui_1.Toolbar, null,
        React.createElement(ra_ui_materialui_1.SaveButton, null),
        React.createElement(material_1.Button, { onClick: function () {
                editorRef.current.commands.setContent('<h3>Here is my template</h3>');
            } }, "Use template"))); };
    return (React.createElement(ra_ui_materialui_1.AdminContext, { i18nProvider: i18nProvider },
        React.createElement(ra_core_1.ResourceContextProvider, { value: "posts" },
            React.createElement(material_1.Card, null,
                React.createElement(ra_ui_materialui_1.SimpleForm, __assign({ defaultValues: { body: 'Hello World' }, toolbar: React.createElement(EditorToolbar, null), onSubmit: function () { } }, props),
                    React.createElement(RichTextInput_1.RichTextInput, { source: "body", editorOptions: __assign(__assign({}, RichTextInput_1.DefaultEditorOptions), { onCreate: function (_a) {
                                var editor = _a.editor;
                                editorRef.current = editor;
                            } }) }),
                    React.createElement(FormInspector, null))))));
};
exports.EditorReference = EditorReference;
var dataProvider = (0, ra_data_fakerest_1.default)({
    posts: [
        { id: 1, body: 'Post 1' },
        { id: 2, body: 'Post 2' },
        { id: 3, body: 'Post 3' },
    ],
    tags: [
        { id: 1, name: 'tag1', post_id: 1 },
        { id: 2, name: 'tag2', post_id: 1 },
        { id: 3, name: 'tag3', post_id: 2 },
        { id: 4, name: 'tag4', post_id: 2 },
        { id: 5, name: 'tag5', post_id: 3 },
        { id: 6, name: 'tag6', post_id: 3 },
    ],
});
var MyRichTextInput = function (props) {
    var record = (0, ra_core_1.useRecordContext)();
    var tags = (0, ra_core_1.useGetManyReference)('tags', {
        target: 'post_id',
        id: record.id,
    });
    var editorOptions = React.useMemo(function () {
        var _a, _b;
        return __assign(__assign({}, RichTextInput_1.DefaultEditorOptions), { extensions: __spreadArray(__spreadArray([], RichTextInput_1.DefaultEditorOptions.extensions, true), [
                extension_mention_1.default.configure({
                    HTMLAttributes: {
                        class: 'mention',
                    },
                    suggestion: suggestions((_b = (_a = tags.data) === null || _a === void 0 ? void 0 : _a.map(function (t) { return t.name; })) !== null && _b !== void 0 ? _b : []),
                }),
            ], false) });
    }, [tags.data]);
    return React.createElement(RichTextInput_1.RichTextInput, __assign({ editorOptions: editorOptions }, props));
};
var CustomOptions = function () { return (React.createElement(ra_core_1.TestMemoryRouter, { initialEntries: ['/posts/1'] },
    React.createElement(ra_ui_materialui_1.AdminContext, { dataProvider: dataProvider },
        React.createElement(react_router_dom_1.Routes, null,
            React.createElement(react_router_dom_1.Route, { path: "/posts/:id", element: React.createElement(ra_ui_materialui_1.Edit, { resource: "posts", actions: React.createElement(ra_ui_materialui_1.TopToolbar, null,
                        React.createElement(ra_ui_materialui_1.PrevNextButtons, null)) },
                    React.createElement(ra_ui_materialui_1.SimpleForm, null,
                        React.createElement(MyRichTextInput, { source: "body" }))) }))))); };
exports.CustomOptions = CustomOptions;
var MentionList = React.forwardRef(function (props, ref) {
    var _a = React.useState(0), selectedIndex = _a[0], setSelectedIndex = _a[1];
    var selectItem = function (index) {
        var item = props.items[index];
        if (item) {
            props.command({ id: item });
        }
    };
    var upHandler = function () {
        setSelectedIndex((selectedIndex + props.items.length - 1) % props.items.length);
    };
    var downHandler = function () {
        setSelectedIndex((selectedIndex + 1) % props.items.length);
    };
    var enterHandler = function () {
        selectItem(selectedIndex);
    };
    React.useEffect(function () { return setSelectedIndex(0); }, [props.items]);
    React.useImperativeHandle(ref, function () { return ({
        onKeyDown: function (_a) {
            var event = _a.event;
            if (event.key === 'ArrowUp') {
                upHandler();
                return true;
            }
            if (event.key === 'ArrowDown') {
                downHandler();
                return true;
            }
            if (event.key === 'Enter') {
                enterHandler();
                return true;
            }
            return false;
        },
    }); });
    return (React.createElement(material_1.Paper, null,
        React.createElement(material_1.List, { dense: true, disablePadding: true }, props.items.length ? (props.items.map(function (item, index) { return (React.createElement(material_1.ListItemButton, { dense: true, selected: index === selectedIndex, key: index, onClick: function () { return selectItem(index); } }, item)); })) : (React.createElement(material_1.ListItem, { className: "item", dense: true },
            React.createElement(material_1.ListItemText, null, "No result"))))));
});
var suggestions = function (tags) {
    return {
        items: function (_a) {
            var query = _a.query;
            return tags
                .filter(function (item) {
                return item.toLowerCase().startsWith(query.toLowerCase());
            })
                .slice(0, 5);
        },
        render: function () {
            var component;
            var popup;
            return {
                onStart: function (props) {
                    component = new react_1.ReactRenderer(MentionList, {
                        props: props,
                        editor: props.editor,
                    });
                    if (!props.clientRect) {
                        return;
                    }
                    popup = (0, tippy_js_1.default)('body', {
                        getReferenceClientRect: props.clientRect,
                        appendTo: function () { return document.body; },
                        content: component.element,
                        showOnCreate: true,
                        interactive: true,
                        trigger: 'manual',
                        placement: 'bottom-start',
                    });
                },
                onUpdate: function (props) {
                    if (component) {
                        component.updateProps(props);
                    }
                    if (!props.clientRect) {
                        return;
                    }
                    if (popup && popup[0]) {
                        popup[0].setProps({
                            getReferenceClientRect: props.clientRect,
                        });
                    }
                },
                onKeyDown: function (props) {
                    if (popup && popup[0] && props.event.key === 'Escape') {
                        popup[0].hide();
                        return true;
                    }
                    if (!component.ref) {
                        return false;
                    }
                    return component.ref.onKeyDown(props);
                },
                onExit: function () {
                    queueMicrotask(function () {
                        if (popup && popup[0] && !popup[0].state.isDestroyed) {
                            popup[0].destroy();
                        }
                        if (component) {
                            component.destroy();
                        }
                        // Remove references to the old popup and component upon destruction/exit.
                        // (This should prevent redundant calls to `popup.destroy()`, which Tippy
                        // warns in the console is a sign of a memory leak, as the `suggestion`
                        // plugin seems to call `onExit` both when a suggestion menu is closed after
                        // a user chooses an option, *and* when the editor itself is destroyed.)
                        popup = undefined;
                        component = undefined;
                    });
                },
            };
        },
    };
};
//# sourceMappingURL=RichTextInput.stories.js.map